//+------------------------------------------------------------------+
//|                                       Example EA DLL Window      |
//|                                       Copyright  2014, C.O.D.E. |
//|                                       FREEWARE                   |
//|                                                                  |
//| Example showing usage of DLL windows within EAs                  |
//| This example allows multiple instances of this EA to use         |
//| the DLL : EADLLWindow                                            |
//+------------------------------------------------------------------+

#property copyright ""
#property link      ""

#include <WinUser32.mqh>


#import "EADLLwindow.dll"
int initdll(string s,int wnd);
int deinitdll(int wnd);
string getmsg(int wnd);
void postmsg(int wnd,string s);
void removesentmsg(int msgid);
#import

#define  CHART_CMD_UPDATE_DATA            33324

bool DLLIsInitilised=false;


string msginstr;
int thischarthwnd;
int messagecount=0;
double lastclose=0.0;
datetime lasttime;
double rsival;
int rsiperiod;

int init()
{
   thischarthwnd = WindowHandle(Symbol(), Period());
   lasttime = TimeLocal();



   if (!DLLIsInitilised)
   {
      string tmps = Symbol()+" "+Period();
      if (thischarthwnd !=0)
      {
         if (initdll(tmps,thischarthwnd) != 1) Alert(tmps+" ("+thischarthwnd+") Error Initialising EA DLL ");
         else DLLIsInitilised = true;
      }
   }

   
   return(0);
}


int deinit()
{

   if (!DLLIsInitilised) return(0);
   
   if (deinitdll(thischarthwnd) !=1) Alert("Error DeInitialising EA DLL");
 
   return(0);
}




int start()
{
   
   if (!DLLIsInitilised) return(0);

   postmsg(thischarthwnd,"LOGMSG,Window handle for "+Symbol()+" "+Period()+" = "+thischarthwnd);

   while (true)
   {
   
      //send the current close price to our window
      // If or when it changes
      if (lastclose != Close[0])
      {

         lastclose = Close[0];
         postmsg(thischarthwnd,"CURPRICE,"+DoubleToStr(lastclose,Digits));

      }

      
      // post a log Message every 15 (ish) seconds 
      if (TimeLocal() > lasttime +15)
      {
         lasttime = TimeLocal();
         
         messagecount ++;
         
         postmsg(thischarthwnd,"LOGMSG,Message #"+messagecount+" For "+Symbol()+" "+Period()+" @ "+TimeToStr(lasttime,TIME_SECONDS));
         
      }


      //Process any messages we get from the DLL window
      
      msginstr = getmsg(thischarthwnd);            
      while ( msginstr != "")
      {
         if (getcsvstr(msginstr,1) == "GETRSI")
         {  
             rsiperiod = StrToInteger(getcsvstr(msginstr,2));
             rsival = iRSI(Symbol(),Period(),rsiperiod,PRICE_CLOSE,0);
             postmsg(thischarthwnd,"RSIRESULT,"+Symbol()+" "+Period()+" RSI("+rsiperiod+") = "+DoubleToStr(rsival,2));
             
         }

         removesentmsg(StrToInteger(getcsvstr(msginstr,getcsvcount(msginstr))));
          
         msginstr = getmsg(thischarthwnd);     
      }
  
 

   
      if (IsStopped()) break;
      RefreshRates();
      PostMessageA(thischarthwnd,WM_COMMAND,CHART_CMD_UPDATE_DATA,0);
      Sleep(5);
   }

   
   return(0);
}




//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//############## UTILITY FUNCTIONS 
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


// get number of fields in a csv string
int getcsvcount(string s)
{
 int res=1;
 int x=0,slen;
 
 slen = StringLen(s);
 
 if (slen == 0) return(0);
 

 while (x < slen )
 {
   if (StringSubstr(s,x,1) ==",") res++;
   x++;
 }

 return(res); 
} 

// return a field of a csv string
string getcsvstr(string s,int pos)
{
 int tpos=1;
 int x=0,slen;
 string sres="";
 
 slen = StringLen(s);
 
  while ((tpos < pos) && (x < slen))
  {
   if (StringSubstr(s,x,1) ==",") tpos++;
   
    x++;
  }
  
  
  while ((x< slen) && (StringSubstr(s,x,1) !=","))
  {
   sres = sres + StringSubstr(s,x,1);
   x++;
  }
  return(sres);

}

